use cdtypes::types::sector::*;

pub struct SubModeBuilder {
    sub_mode: SubMode
}

impl SubModeBuilder {
    pub fn new_mode1() -> Self {
        SubModeBuilder{sub_mode: SubMode::default_form1()}
    }

    pub fn set_eor(mut self) -> Self {
        self.sub_mode.set_eor();
        self
    }

    pub fn set_eof(mut self) -> Self {
        self.sub_mode.set_eof();
        self
    }

    pub fn create(self) -> SubMode {
        self.sub_mode
    }
}

pub fn create_xa_data_for_raw(mut sub_mode: SubMode, data: &[u8; Mode2Form1::DATA_SIZE]) -> Mode2Form1 {
    let mut sector = Mode2Form1::new();

    sub_mode.set_data();

    sector.sub_header.sub_mode = sub_mode;
    sector.data = *data;
    sector
}

pub fn create_xa_data_for<T>(sub_mode: SubMode, data: &T) -> Mode2Form1 {
    create_xa_data_for_raw(sub_mode, unsafe {std::mem::transmute::<&T, &[u8; Mode2Form1::DATA_SIZE]>(data)})
}

pub fn create_xa_data_zero() -> Mode2Form1 {
    create_xa_data_for_raw(SubMode::default_form1(), &[0u8; Mode2Form1::DATA_SIZE])
}